{-# OPTIONS_GHC -fglasgow-exts #-}

module Substitution where {

import Option;

decomp :: forall a b. [a] -> [b] -> Maybe [(a, b)];
decomp [] [] = Just [];
decomp (uu : uv) [] = Nothing;
decomp [] (uw : ux) = Nothing;
decomp (s : ss) (t : ts) =
  (case decomp ss ts of {
    Nothing -> Nothing;
    Just pairs -> Just ((s, t) : pairs);
  });

}
