{-# OPTIONS_GHC -fglasgow-exts #-}

module Graph where {

import ErrorMonad;
import List;
import Eithera;

check_edges ::
  forall a.
    (a -> [Char]) -> ((a, a) -> Bool) -> [a] -> [a] -> Eithera [Char] ();
check_edges ss g c d =
  catcha
    (checkAllMI
      (\ n ->
        catcha
          (checkAllMI
            (\ m ->
              checkB (not (g (m, n)))
                (concata
                  [['e', 'd', 'g', 'e', ' ', 'f', 'r', 'o', 'm', ' '], ss n,
                    [' ', 't', 'o', ' '], ss m]))
            d)
          (\ x -> errora (snd x)))
      c)
    (\ x -> errora (snd x));

check_graph_decomp ::
  forall a.
    (a -> [Char]) -> ((a, a) -> Bool) -> [(Bool, [a])] -> Eithera [Char] ();
check_graph_decomp ss g rcs =
  bind (catcha (checkAllCombinations (check_edges ss g) (mapa snd rcs))
         (\ x -> errora (snd x)))
    (\ x ->
      catcha
        (checkAllMI (\ c -> check_edges ss g c c)
          (mapa snd (filtera (\ rc -> not (fst rc)) rcs)))
        (\ xa -> errora (snd xa)));

}
