{-# OPTIONS_GHC -fglasgow-exts #-}

module Util where {

import HOL;
import List;

anya :: forall a. (a -> Bool) -> [a] -> Bool;
anya uu [] = False;
anya p (x : xs) = p x || anya p xs;

list_union :: forall a. (Eq a) => [a] -> [a] -> [a];
list_union [] ys = ys;
list_union (x : xs) ys =
  let {
    zs = list_union xs ys;
  } in (if member x zs then zs else x : zs);

lookupa :: forall a b. (Eq a) => a -> [(a, b)] -> Maybe b;
lookupa uu [] = Nothing;
lookupa a ((a', b) : xs) = (if a == a' then Just b else lookupa a xs);

}
